import { defineComponent as w, ref as v, watch as B, onBeforeUnmount as E, createBlock as A, openBlock as g, Transition as L, withCtx as h, withDirectives as V, createElementVNode as m, normalizeStyle as $, normalizeClass as p, withModifiers as C, createElementBlock as y, createCommentVNode as b, renderSlot as D, vShow as O, onMounted as T } from "vue";
const N = ["aria-describedby"], _ = { role: "document" }, I = /* @__PURE__ */ w({
  __name: "HtmlDialog",
  props: {
    showBackdrop: { type: Boolean, default: !0 },
    closeOnBackdropClick: { type: Boolean, default: !0 },
    closeOnEscape: { type: Boolean, default: !0 },
    showCloseButton: { type: Boolean, default: !0 },
    titleId: String,
    dialogClass: String,
    backdropClass: String,
    closeButtonClass: String,
    enterActiveClass: { type: String, default: "fade-enter-active" },
    leaveActiveClass: { type: String, default: "fade-leave-active" },
    transitionDuration: { type: Number, default: 300 }
  },
  emits: ["open", "close"],
  setup(r, { expose: c, emit: a }) {
    const o = r, i = v(null), n = v(!1);
    function s() {
      n.value = !0;
    }
    function u() {
      n.value = !1;
    }
    function f(t) {
      t.target === t.currentTarget && o.closeOnBackdropClick && u();
    }
    function d(t) {
      t.key === "Escape" && o.closeOnEscape && u();
    }
    return B(n, (t) => {
      t ? window.addEventListener("keydown", d) : window.removeEventListener("keydown", d);
    }), E(() => {
      window.removeEventListener("keydown", d);
    }), c({
      openDialog: s,
      closeDialog: u
    }), (t, e) => (g(), A(L, {
      "enter-active-class": t.enterActiveClass,
      onAfterEnter: e[2] || (e[2] = (l) => t.$emit("open")),
      "leave-active-class": t.leaveActiveClass,
      onAfterLeave: e[3] || (e[3] = (l) => t.$emit("close"))
    }, {
      default: h(() => [
        V(m("div", {
          class: p(["backdrop", t.backdropClass]),
          onPointerup: f,
          role: "presentation",
          style: $({ "--transition-duration": t.transitionDuration + "ms" })
        }, [
          m("dialog", {
            ref_key: "dialogEl",
            ref: i,
            open: "",
            class: p(["dialog", t.dialogClass]),
            role: "dialog",
            onClick: e[0] || (e[0] = C(() => {
            }, ["stop"])),
            onTouchend: e[1] || (e[1] = C(() => {
            }, ["stop"])),
            "aria-modal": "true",
            "aria-describedby": t.titleId
          }, [
            m("div", _, [
              t.showCloseButton ? (g(), y("button", {
                key: 0,
                class: p(["close-button", t.closeButtonClass]),
                onPointerup: u,
                "aria-label": "Close the modal"
              }, "×", 34)) : b("", !0),
              D(t.$slots, "default", {}, void 0, !0)
            ])
          ], 42, N)
        ], 38), [
          [O, n.value && t.showBackdrop]
        ])
      ]),
      _: 3
    }, 8, ["enter-active-class", "leave-active-class"]));
  }
}), S = (r, c) => {
  const a = r.__vccOpts || r;
  for (const [o, i] of c)
    a[o] = i;
  return a;
}, F = /* @__PURE__ */ S(I, [["__scopeId", "data-v-fcf88e03"]]), P = { role: "document" }, M = /* @__PURE__ */ w({
  __name: "FullNativeDialog",
  props: {
    modelValue: Boolean,
    closeOnEscape: { type: Boolean, default: !0 },
    closeButton: { type: Boolean, default: !0 },
    dialogClass: String,
    closeButtonClass: String,
    enterActiveClass: { type: String, default: "fade-enter-active" },
    leaveActiveClass: { type: String, default: "fade-leave-active" },
    transitionDuration: { type: Number, default: 300 }
  },
  emits: ["update:modelValue", "open", "close"],
  setup(r, { emit: c }) {
    const a = r, o = v(null), i = v(!1), n = v(null), s = c;
    function u() {
      o.value && (o.value.open || (o.value.showModal(), s("update:modelValue", !0), s("open"), o.value.focus()));
    }
    function f() {
      !o.value || i.value || (i.value = !0, o.value.classList.add(a.leaveActiveClass), setTimeout(() => {
        var e, l;
        (e = o.value) == null || e.close(), i.value = !1, (l = o.value) == null || l.classList.remove(a.leaveActiveClass), s("update:modelValue", !1), s("close");
      }, a.transitionDuration));
    }
    B(
      () => a.modelValue,
      (e) => {
        var l;
        e ? (u(), n.value && clearTimeout(n.value), (l = o.value) == null || l.classList.add(a.enterActiveClass), n.value = window.setTimeout(() => {
          var k;
          (k = o.value) == null || k.classList.remove(a.enterActiveClass), n.value = null;
        }, a.transitionDuration)) : f();
      }
    );
    function d(e) {
      a.closeOnEscape || e.preventDefault();
    }
    function t() {
      s("update:modelValue", !1), s("close");
    }
    return T(() => {
      var e, l;
      (e = o.value) == null || e.addEventListener("cancel", d), (l = o.value) == null || l.addEventListener("close", t);
    }), E(() => {
      var e, l;
      (e = o.value) == null || e.removeEventListener("cancel", d), (l = o.value) == null || l.removeEventListener("close", t);
    }), (e, l) => (g(), y("dialog", {
      ref_key: "dialogEl",
      ref: o,
      class: p([e.dialogClass]),
      role: "dialog",
      onPointerdown: l[0] || (l[0] = C(() => {
      }, ["stop"])),
      "aria-modal": "true"
    }, [
      m("div", P, [
        e.closeButton ? (g(), y("button", {
          key: 0,
          class: p(["close-button", e.closeButtonClass]),
          onPointerdown: C(f, ["prevent"]),
          "aria-label": "Close dialog",
          type: "button"
        }, "×", 34)) : b("", !0),
        D(e.$slots, "default", {}, void 0, !0)
      ])
    ], 34));
  }
}), H = /* @__PURE__ */ S(M, [["__scopeId", "data-v-6c2d8e9f"]]);
export {
  H as FullNativeDialog,
  F as HtmlDialog
};
